import { NgModule, ModuleWithProviders } from '@angular/core';

import { 
  Agent,
  AuthService,
  CleverQueryService,
  FormFactory,
  AssetService,
  NotifService,
  SpyService,
  StorageService,
  TitleService,
  UtilsService
 } from "./services";

import { SpyDirective } from "./directives";

@NgModule({
  imports: [],
  exports: [ SpyDirective ],
  declarations: []
})
export class NgFoundationModule { 
  public static forRoot(): ModuleWithProviders {
    return {
      ngModule: NgFoundationModule, 
      providers: [
        Agent,
        AuthService,
        CleverQueryService,
        FormFactory,
        AssetService,
        NotifService,
        SpyService,
        StorageService,
        TitleService,
        UtilsService
      ]
    };
  }

  public static forChild(): ModuleWithProviders {
    return {
      ngModule: NgFoundationModule, 
      providers: []
    };
  }
}
