import { NgModule, ModuleWithProviders } from '@angular/core';

import { 
  Agent,
  CleverQueryService,
  AssetService,
  NotifService,
  SpyService,
  StorageService,
  TitleService,
  UtilsService
 } from "./services";

import { SpyDirective } from "./directives";

import { NGFOUNDATION_CONFIG_DEFAULT, NGFOUNDATION_CONFIG_DEFAULT_VALUES } from "./ng-foundation.config";

@NgModule({
  imports: [],
  exports: [ SpyDirective ],
  declarations: []
})
export class NgFoundationModule { 
  public static forRoot(): ModuleWithProviders {
    return {
      ngModule: NgFoundationModule, 
      providers: [
        Agent,
        CleverQueryService,
        AssetService,
        NotifService,
        SpyService,
        StorageService,
        TitleService,
        UtilsService,
        { provide: NGFOUNDATION_CONFIG_DEFAULT, useValue: NGFOUNDATION_CONFIG_DEFAULT_VALUES }
      ]
    };
  }

  public static forChild(): ModuleWithProviders {
    return {
      ngModule: NgFoundationModule, 
      providers: []
    };
  }
}
