import { Component, OnInit, Input } from '@angular/core';
import { ActivatedRoute } from '@angular/router';

import { ResourceContract, ResourceService  } from "./index";

@Component({
  selector: 'ng-resource',
  templateUrl: './resource.component.html'
})
export class ResourceComponent implements OnInit{

  @Input() resource: ResourceContract;

  constructor(
    private route: ActivatedRoute,
    private resourceService: ResourceService
  )
  {}

  ngOnInit(){
    this.refresh();
  }  

  refresh(){
    this.resourceService.config = (this.resource) ? this.resource : this.route.snapshot.data['resource'];
  }
}
