import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { NgFoundationModule, NGFOUNDATION_CONFIG } from '@springbuck/ng-foundation';
import { NgWebgetsModules, NGWEBGETS_CONFIG } from '@springbuck/ng-webgets';

import { RESOURCE_ROUTES } from './resource.routes';
import { 
  CollectionComponent, 
  FormComponent, 
  SoloComponent, 
  NGFOUNDATION_CONFIG_CUSTOM_VALUE,
  NGWEBGETS_CONFIG_CUSTOM_VALUES } from './index';


@NgModule({
  declarations: [
    CollectionComponent,
    FormComponent,
    SoloComponent
  ],
  imports: [ 
    NgFoundationModule.forChild(),
    NgWebgetsModule.forChild(),
    RouterModule.forChild(RESOURCE_ROUTES),
  ],
  exports: [
    CollectionComponent,
    FormComponent,
    SoloComponent
  ],
  providers: [
    { provide: NGFOUNDATION_CONFIG, useValue: NGFOUNDATION_CONFIG_CUSTOM_VALUE },
    { provide: NGFOUNDATION_CONFIG, useValue: NGWEBGETS_CONFIG_CUSTOM_VALUES }
  ]
})
export class ResourceModule{}
  